{  DEMO PROGRAM MADE BY MATTHIAS MOLSKI, July 2011
   VISIT: http://www.Freepascal-meets-SDL.net/  }
  
PROGRAM chap8a;
USES CRT, SDL, GL, GLU;

VAR
userkey:CHAR;
screen, picture,picture1:pSDL_SURFACE;
h,hh,th,thh:REAL;
ogl_texture:pGLUINT;

BEGIN

//some calculations needed for a regular tetrahedron with side length of 1
h:=SQRT(0.75); //height of equilateral triangle
hh:=h/2;       //half height of equilateral triangle
th:=0.75;      //height of tetrahedron
thh:=th/2;     //half height of tetrahedron

SDL_INIT(SDL_INIT_VIDEO);

SDL_GL_SETATTRIBUTE(SDL_GL_RED_SIZE, 5);
SDL_GL_SETATTRIBUTE(SDL_GL_GREEN_SIZE, 5);
SDL_GL_SETATTRIBUTE(SDL_GL_BLUE_SIZE, 5);
SDL_GL_SETATTRIBUTE(SDL_GL_DEPTH_SIZE, 32);
SDL_GL_SETATTRIBUTE(SDL_GL_DOUBLEBUFFER, 1);

screen:=SDL_SETVIDEOMODE(640, 480, 0, SDL_OPENGL);
IF screen=NIL THEN HALT;

//preparing SDL image
//picture:=SDL_LOADBMP('Floor02.bmp');
picture:=SDL_LOADBMP('Floor07.bmp');
//picture:=SDL_LOADBMP('Floor05.bmp');
//picture:=SDL_LOADBMP('Floor09.bmp');
IF picture=NIL THEN HALT;

//preparing OpenGL texture
NEW(ogl_texture);
glGENTEXTURES(1, ogl_texture);
glBINDTEXTURE(GL_TEXTURE_2D, ogl_texture^);
glTEXIMAGE2D(GL_TEXTURE_2D, 0, GL_RGB, picture^.w, picture^.h, 0,
             GL_RGB, GL_UNSIGNED_BYTE, picture^.pixels);
glTEXPARAMETERi(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
glTEXPARAMETERi(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
SDL_FREESURFACE(picture);

glCLEARCOLOR(0.0, 0.0, 1.0, 0.0);
glVIEWPORT(0,0,640,480);
glMATRIXMODE(GL_PROJECTION);
glLOADIDENTITY;
gluPERSPECTIVE(45.0, 640.0/480.0, 1.0, 3.0);
glMATRIXMODE(GL_MODELVIEW);
glLOADIDENTITY;
glCLEAR(GL_COLOR_BUFFER_BIT);
glENABLE(GL_CULL_FACE);
glENABLE(GL_SHADE_MODEL);
glENABLE(GL_POINT_SMOOTH);
glENABLE(GL_LINE_SMOOTH);
glENABLE(GL_DITHER);
glENABLE(GL_BLEND);
glENABLE(GL_NORMALIZE);
glENABLE(GL_AUTO_NORMAL);
glTRANSLATEf(0.0, 0.0, -2.0);

REPEAT
SDL_DELAY(50);

glROTATEf(5, 0.0, 1.0, 0.0);
glCLEAR(GL_COLOR_BUFFER_BIT);

//drawing textured face of tetrahedron
glENABLE(GL_TEXTURE_2D);
glBEGIN(GL_TRIANGLES);
    glTEXCOORD2f(2,2);
    glVERTEX3f(thh, 0.0, 0.0);
    glTEXCOORD2f(0,0);
    glVERTEX3f(-thh, hh, 0.0);
    glTEXCOORD2f(0,2);
    glVERTEX3f(-thh, -hh, 0.5);
    glTEXCOORD2f(0,2);
    glVERTEX3f(-thh, -hh, 0.5);	
glEND;

glBEGIN(GL_TRIANGLES);
    glTEXCOORD2f(-2,2);
    glVERTEX3f(thh, 0.0, 0.0);
    glTEXCOORD2f(-0,0);	
    glVERTEX3f(-thh, -hh, -0.5);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, hh, 0.0);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, hh, 0.0);		
glEND;

glBEGIN(GL_TRIANGLES);
    glTEXCOORD2f(-2,2);
    glVERTEX3f(thh, 0.0, 0.0);
    glTEXCOORD2f(-0,0);	
    glVERTEX3f(-thh, -hh, 0.5);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, -hh, -0.5);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, -hh, -0.5);	
glEND;

glBEGIN(GL_TRIANGLES);
    glTEXCOORD2f(-2,2);
    glVERTEX3f(-thh, -hh, 0.5);
    glTEXCOORD2f(-0,0);	
    glVERTEX3f(-thh, hh, 0.0);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, -hh, -0.5);
    glTEXCOORD2f(-0,2);	
    glVERTEX3f(-thh, -hh, -0.5);	
glEND;
glDISABLE(GL_TEXTURE_2D);

//drawing remaining three untextured faces
{glBEGIN(GL_TRIANGLES);
    glCOLOR3f(0.0, 1.0, 1.0);
    glVERTEX3f(thh, 0.0, 0.0);
    glVERTEX3f(-thh, -hh, -0.5);
    glVERTEX3f(-thh, hh, 0.0);

    glCOLOR3f(1.0, 0.0, 1.0);
    glVERTEX3f(thh, 0.0, 0.0);
    glVERTEX3f(-thh, -hh, 0.5);
    glVERTEX3f(-thh, -hh, -0.5);

    glCOLOR3f(1.0, 1.0, 1.0);
    glVERTEX3f(-thh, -hh, 0.5);
    glVERTEX3f(-thh, hh, 0.0);
    glVERTEX3f(-thh, -hh, -0.5);
glEND;}

SDL_GL_SWAPBUFFERS;
UNTIL keypressed;

glDELETETEXTURES(1, ogl_texture);
DISPOSE(ogl_texture);
SDL_QUIT;
END.
